class ComConnection
  attr_reader :portname, :databits, :speed, :parity, :stopbits, :flowcontrol, :readtimeout, :writetimeout, :usereadbuffer
  
  def initialize(args)
    @portname      = args[:portname]
    @databits      = args[:databits]       || default_databits
    @speed         = args[:speed]          || default_speed
    @parity        = args[:parity]         || default_parity
    @stopbits      = args[:stopbits]       || default_stopbits
    @flowcontrol   = args[:flowcontrol]    || default_flowcontrol
    @readtimeout   = args[:readtimeout]    || default_readtimeout
    @writetimeout  = args[:writetimeout]   || default_writetimeout
    @usereadbuffer = args[:usereadbuffer]  || default_usereadbuffer
  end

  def port_config_string  
    "PortName=#{portname};DataBits=#{databits};Speed=#{speed};Parity=#{parity};StopBits=#{stopbits};FlowControl=#{flowcontrol};ReadTimeout=#{readtimeout};WriteTimeout=#{writetimeout};UseReadBuffer=#{usereadbuffer}"
  end
    
  private
    def default_databits
      8
    end  

    def default_speed
      9600
    end

    def default_parity
      'N'
    end

    def default_stopbits
      1
    end

    def default_flowcontrol
      'X'
    end

    def default_readtimeout
      40000
    end  

    def default_writetimeout
      50
    end

    def default_usereadbuffer
      0
    end  
end 
