require_relative 'ethernet_connection.rb'
require_relative 'com_connection.rb'

class ConnectionFactory
  attr_reader :connection

  def initialize(args)
    hash_with_indifferent_access(args)
    if args[:host].nil?
      @connection = ComConnection.new(args)
    else
      @connection = EthernetConnection.new(args)
    end  
  end

  def port_config_string
    @connection.port_config_string
  end

  private
    def hash_with_indifferent_access(args)
      args.default_proc = proc do |h, k|
         case k
           when String then sym = k.to_sym; h[sym] if h.key?(sym)
           when Symbol then str = k.to_s; h[str] if h.key?(str)
         end
      end 
    end  

end  
