class EthernetConnection
  attr_reader :portname, :host, :port, :connectiontimeout, :timeout
  def initialize(args)
    @portname          = 'TCP/IP'
    @host              = args[:host]
    @port              = args[:port]              || default_port
    @connectiontimeout = args[:connectiontimeout] || default_connectiontimeout
    @timeout           = args[:timeout]           || default_timeout
  end

  def port_config_string  
    "PortName=#{portname};Host=#{host};Port=#{port};ConnectionTimeout=#{connectiontimeout};Timeout=timeout"
  end
    
  private
    def default_port
      6001
    end

    def default_connectiontimeout
      10000
    end

    def default_timeout
      30000
    end  
end  
